# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b302"
os.chdir("/Users/saliola/.sage/sage_notebook/worksheets/admin/7/cells/0")
sage.server.notebook.interact.SAGE_CELL_ID=0
html('<h2>Tangent line grapher</h2>')
@interact
def tangent_line(f = input_box(default=sin(x)), xbegin = slider(Integer(0),Integer(10),Integer(1)/Integer(10),Integer(0)), xend = slider(Integer(0),Integer(10),Integer(1)/Integer(10),Integer(10)), x0 = slider(Integer(0), Integer(1), Integer(1)/Integer(100), Integer(1)/Integer(2))):
    prange = [xbegin, xend]
    x0i = xbegin + x0*(xend-xbegin)
    var('x')
    df = diff(f)
    tanf = f(x0i) + df(x0i)*(x-x0i)
    fplot = plot(f, prange[Integer(0)], prange[Integer(1)])
    print 'Tangent line is y = ' + tanf._repr_()
    tanplot = plot(tanf, prange[Integer(0)], prange[Integer(1)], rgbcolor = (Integer(1),Integer(0),Integer(0)))
    fmax = f.find_maximum_on_interval(prange[Integer(0)], prange[Integer(1)])[Integer(0)]
    fmin = f.find_minimum_on_interval(prange[Integer(0)], prange[Integer(1)])[Integer(0)]
    show(fplot + tanplot, xmin = prange[Integer(0)], xmax = prange[Integer(1)], ymax = fmax, ymin = fmin)

print "e302"
